#![cfg_attr(not(debug_assertions), windows_subsystem = "windows")] 
// hide console window on Windows in release

pub use crate::node::Node;
pub use crate::app::App;

mod app;
mod node;

pub const TOR_DATA: &str = &"/tmp/tor-rust";
pub const TOR_LOG: &str = &"/tmp/tor-rust/tor.log";
pub const RADIO_STREAM: &str = &"radio.ogg";
pub const NODE_LOG: &str = &"./node.log";

fn cleanup() {
    let r: std::io::Result<()> = std::fs::remove_file(&RADIO_STREAM);
    match r {
        _ => ()
    }
}

fn main() {
    let app: app::App = app::App::default();
    let options: eframe::NativeOptions = eframe::NativeOptions::default();
    eframe::run_native(
        "node gui",
        options,
        Box::new(|_cc| Box::new(app)),
    );
    let _ = cleanup();
}
